package client;

import java.io.*;

public class ReadThread extends Thread {
	private ChatClient owner;
	private InputStream is;
	
	ReadThread(ChatClient owner, InputStream is) {
		super();
		this.owner = owner;
		this.is = is;
	}
	
	public void run() {
		try {
			boolean moreData = true;
			while (moreData) {
				byte[] input = new byte[65535]; 
				if (is.read(input) > -1) {
					String inputString = new String(input).trim();
					String prefix = "";
					switch (inputString.charAt(0)) {
						case 'E':
							prefix = "-- ";
						case 'M':
							owner.log(prefix + inputString.substring(2));
							break;
						default:
							owner.log("-- Recieved unknown command \"" + inputString + "\" from server.");
							break;
					}
				} else {
					moreData = false;
				}
			}
		} catch (Exception e) {
			owner.log("-- Failure while reading input data! Restart the client.");
			owner.disconnect();
		}
	}
}
