package server;
import java.io.*;

public class ParticipantThread extends Thread {
	Mailbox box;
	Participant part = null;
	ChatServer owner = null;
		
	public ParticipantThread(ChatServer owner, Mailbox box, Participant part){
		super();
		this.box = box;
		this.part = part;
		this.owner = owner;
	}
	
	public void run() {
		try {			
			InputStream is = part.getSocket().getInputStream();
			boolean moreData = true;			
			while (moreData) {
				byte[] input = new byte[65535]; 
				if (is.read(input) > -1) {					
					String inputString = new String(input).trim();
					switch(inputString.charAt(0)){
						case 'M':
							box.addMessage("M:<" + part.getName() + "> " + inputString.substring(2));
							break;
						case 'N':
							String newName = inputString.substring(2);
							if (!owner.nameTaken(newName)) {
								String oldName = part.setName(newName);
								box.addMessage("E:\"" + oldName + "\" changed name to \"" + part.getName() + "\"");
							} else {
								part.getSocket().getOutputStream().write(("E:The name \"" + newName + "\" is already taken.").getBytes());
							}
							break;
						case 'Q':
							moreData = false;
							is.close();
							break;
						default:
							System.err.println("Recieved unknown command \"" + inputString + "\" from client \"" + part.getName() + "\"");
							break;
					}
								
				} else {
					moreData = false;
				}
			}
			owner.removePart(part);
													
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}

}
